<?php
/**
 * classes/ibit_Action_EvaluationConfiguration.class.php
 *
 * @author  Michael Riehemann <michael.riehemann@uni-oldenburg.de>
 * @package IBIT_Evaluation
 * @subpackage Action
 */
class ibit_Action_EvaluationRandomize
{
	/**
	 * Enthlt eine Referenz auf das aufrufende Objekt.
	 * @var object $parent Referenz auf das aufrufende Objekt
	 */
	var $parent;

	/**
	 * Konstruktor
	 * @param object $parent Referenz auf das aufrufende Objekt
	 */
	function ibit_Action_EvaluationRandomize( $parent )
	{
		$this->parent = $parent;
	}

	function showSettings()
	{
		//Ausgabe
		$template = $this->parent->parent->getTemplate('admin_randomize');
		$template->set_attribute('template_infos', ibit_EvaluationTemplate::getTemplatesInfo(true));
		$template->set_attribute('semester', ibit_Helper::getEvaluationSemester(true));
		$template->set_attribute('link_result', $this->parent->base_link.'&command=result');
		echo $template->render();
	}

	function showResults()
	{
		$liste = DBManager::Get()->query("SELECT DISTINCT auth.username, auth.Vorname AS vorname, auth.Nachname AS nachname FROM ibit_evaluation AS eval JOIN ibit_evaluation_user AS user ON eval.evaluation_id = user.evaluation_id JOIN auth_user_md5 AS auth ON user.user_id = auth.user_id WHERE eval.semester_id = '{$_POST['semester_id']}' AND eval.evaluation_template_id='{$_POST['activation_template_id']}' AND user.hidden = 0")->fetchAll(PDO::FETCH_ASSOC);

		if(count($liste) > $numbers)
		{
		    //Zufallsgenerator
	    	$numbers = array_rand($liste, $_POST['users']);
			$i = 0;
			$winners = array();
	    	while($i < $_POST['users'])
	    	{
				array_push( $winners, $liste[$numbers[$i]] );
				$i++;
	    	}			
		}
		else 
		{
			StudIPTemplateEngine::showErrorMessage('Es sind nicht gengend Teilnehmer vorhanden.');	
		}

		// Ausgabe
		$template = $this->parent->parent->getTemplate('admin_randomize');
		$template->set_attribute('template_infos', ibit_EvaluationTemplate::getTemplatesInfo(true));
		$template->set_attribute('semester', ibit_Helper::getEvaluationSemester(true));
		$template->set_attribute('link_result', $this->parent->base_link.'&command=result');
		$template->set_attribute('liste', $winners);
		echo $template->render();
	}

}
?>